  -----------------------------
  -- INIT
  -----------------------------

  local addon, ns = ...
  local cfg = CreateFrame("Frame")
  local mediaFolder = "Interface\\AddOns\\sqwUnitframes\\media\\"	

  -----------------------------
  -- CONFIG
  -----------------------------
  
  -- Units
  cfg.showtot = true -- show target of target frame
  cfg.showpet = true -- show pet frame
  cfg.showfocus = true -- show focus frame
  cfg.showfocustarget = true -- show focus target frame
  cfg.ShowPlayerName = true -- show player's name and level
  cfg.ShowTargetPower = false --- show target power       --- For Lynce
  cfg.showBossFrames = true -- show boss frame
  
  -- Raid and Party
  cfg.ShowParty = true  -- show party frames
  cfg.ShowSelfParty = true  -- show self in party
  cfg.party_leader_icon = false  -- Show Leader Icon
  cfg.showPartyHorizontal = false -- shows party frames horizontally
  
  cfg.ShowRaid = false -- show raid frames
  cfg.RaidShowSolo = false -- show raid frames even when solo
  cfg.HideRaidFrameManager = true  --hide raid frame manager

  -- Positioning 
  cfg.PlayerX = -270 -- Player frame's x-offset position from the relative point of the screen
  cfg.PlayerY = -240 -- Player frame's y-offset position from the relative point of the screen
  cfg.PlayerRelativePoint = "CENTER" -- Player frame's reference point of the screen used for X and Y offsets. Possible values are: "TOP"/"BOTTOM"/"LEFT"/"RIGHT"/"CENTER"/"TOPLEFT"/"ROPRIGHT"/"BOTTOMLEFT"/"BOTTOMRIGHT"
  cfg.TargetX = 270 -- Target frame's x-offset position from the relative point of the screen
  cfg.TargetY = -240 -- Target frame's y-offset position from the relative point of the screen
  cfg.TargetRelativePoint = "CENTER" -- Target frame's reference point of the screen used for X and Y offsets. Possible values are: "TOP"/"BOTTOM"/"LEFT"/"RIGHT"/"CENTER"/"TOPLEFT"/"ROPRIGHT"/"BOTTOMLEFT"/"BOTTOMRIGHT"
  cfg.TotX = 0 -- Target of target frame's x-offset position from the relative point of the screen
  cfg.TotY = 8 -- Target of target frame's y-offset position from the relative point of the screen
  cfg.TotRelativePoint = "TOPRIGHT" -- Target of target frame's reference point of the screen used for X and Y offsets. Possible values are: "TOP"/"BOTTOM"/"LEFT"/"RIGHT"/"CENTER"/"TOPLEFT"/"ROPRIGHT"/"BOTTOMLEFT"/"BOTTOMRIGHT"  cfg.PartyX = -290 -- Party Frames Horizontal Position
  cfg.FocusX = 450 -- had 110Focus frame's x-offset position from the relative point of the screen
  cfg.FocusY = 50 -- had 100Focus frame's y-offset position from the relative point of the screen
  cfg.FocusRelativePoint = "TOP" -- Focus frame's reference point of the screen used for X and Y offsets. Possible values are: "TOP"/"BOTTOM"/"LEFT"/"RIGHT"/"CENTER"/"TOPLEFT"/"ROPRIGHT"/"BOTTOMLEFT"/"BOTTOMRIGHT"  cfg.PartyX = -290 -- Party Frames Horizontal Position
  cfg.PartyX = -700 -- Party Frames Horizontal Position
  cfg.PartyY = 280 -- Party Frames Vertical Position
  cfg.RaidX = 405 -- Party Frames Horizontal Position
  cfg.RaidY = -555 -- Party Frames Vertical Position
  cfg.BossX = -10 -- Boss Frames Horizontal Position
  cfg.BossY = -230 -- Boss Frames Vertical Position
  
  -- Auras
  cfg.showPlayerAuras = false -- use a custom player buffs/debuffs frame instead of Blizzard's default.
  cfg.showTargetBuffs = false -- show target buffs
  cfg.showTargetDebuffs = false -- show target debuffs
  cfg.showBossBuffs = false -- show target buffs
  cfg.showBossDebuffs = false -- show target debuffs
  cfg.debuffsOnlyShowPlayer = false -- only show your debuffs on target
  cfg.buffsOnlyShowPlayer = false -- only show your buffs

  -- Plugins
  cfg.enableDebuffHighlight = true -- enable *dispelable* debuff highlight for raid frames
  cfg.showRaidDebuffs = true -- enable important debuff icons to show on raid units
  cfg.showAuraWatch = true -- enable display of HoTs and important player buffs/debuffs on raid frames

  -- Misc
  cfg.showRunebar = true -- show DK's rune bar
  cfg.showClassIcons = true -- Shadow orbs, soul shards, holy power and chi
  cfg.showEclipsebar = true -- show druid's Eclipse bar
  cfg.showShardbar = true -- show Warlock's SoulShard bar
  cfg.showTotemBar = true -- show Shaman Totem timer bar
  cfg.showVengeance = true -- show tank Vengeance bar
  cfg.RCheckIcon = true -- show raid check icon
  cfg.Castbars = true -- use built-in castbars
  cfg.ShowIncHeals = true -- Show incoming heals in player and raid frames
  cfg.showLFDIcons = true -- Show dungeon role icons in raid/party
  
  --cfg.statusbar_texture = mediaFolder.."statusbar4"
  --cfg.statusbar_texture = mediaFolder.."Statusbar"
  cfg.statusbar_texture = mediaFolder.."RenaitreMinionL"
  cfg.powerbar_texture = mediaFolder.."Minimalist"
  cfg.castbar_texture = mediaFolder.."Minimalist"
  cfg.backdrop_texture = mediaFolder.."backdrop"
  cfg.highlight_texture = mediaFolder.."raidbg"
  cfg.debuffhighlight_texture = mediaFolder.."debuff_highlight"
  cfg.backdrop_edge_texture = mediaFolder.."backdrop_edge"
  cfg.debuffBorder = mediaFolder.."iconborder"
  cfg.spark = mediaFolder.."spark"
  cfg.font = mediaFolder.."Calibri.ttf"
  cfg.smallfont = mediaFolder.."Calibri.ttf"
  --cfg.font = mediaFolder.."ROADWAY.ttf"
  --cfg.smallfont = mediaFolder.."Emblem.ttf"
  cfg.raidScale = 1 -- scale factor for raid and party frames
  cfg.partyScale = 1 -- scale factor for party frames
  cfg.scale = 1 -- scale factor for all other frames
  
  -----------------------------
  -- HANDOVER
  -----------------------------
  
  ns.cfg = cfg
