local addon, ns = ...
local cfg = ns.cfg

local tags = oUF.Tags

local SVal = function(val)
	if val then
		if (val >= 1e6) then
			return ("%.1fm"):format(val / 1e6)
		elseif (val >= 1e3) then
			return ("%.1fk"):format(val / 1e3)
		else
			return ("%d"):format(val)
		end
	end
end

local function hex(r, g, b)
	if r then
		if (type(r) == 'table') then
			if(r.r) then r, g, b = r.r, r.g, r.b else r, g, b = unpack(r) end
		end
		return ('|cff%02x%02x%02x'):format(r * 255, g * 255, b * 255)
	end
end
--[[
local iconstring = {
	['TANK'] = '|TInterface\\LFGFrame\\UI-LFG-ICON-PORTRAITROLES.blp:13:13:0:0:64:64:0:19:22:41|t',
	['HEALER'] = '|TInterface\\LFGFrame\\UI-LFG-ICON-PORTRAITROLES.blp:13:13:0:0:64:64:20:39:1:20|t',
	['DAMAGER'] = '|TInterface\\LFGFrame\\UI-LFG-ICON-PORTRAITROLES.blp:13:13:0:0:64:64:20:39:22:41|t',
}

local iconstringsmall = {
	['TANK'] = '|TInterface\\LFGFrame\\LFGRole:14:14:0:0:64:16:32:48:0:16|t',
	['HEALER'] = '|TInterface\\LFGFrame\\LFGRole:14:14:0:0:64:16:48:64:0:16|t',
	['DAMAGER'] = '|TInterface\\LFGFrame\\LFGRole:14:14:0:0:64:16:16:32:0:16|t',
} ]]--

tags.Events["sqw:lfdrole"] = "GROUP_ROSTER_UPDATE PLAYER_ROLES_ASSIGNED"
tags.Methods["sqw:lfdrole"] = function(unit)
	local font = ("Interface\Addons\sqwUnitfranes\Media\PIZZADUDEBULLETS.TTF")
	local role = UnitGroupRolesAssigned(unit)
	if role == "HEALER" then
	--return "|cff7CFC00H|r" --symbol
		return "|cff8AFF30H|r" -- H
		--return "|cff8AFF30Heals|r"
	elseif role == "TANK" then
	--return "|cffF4A460T|r" --symbol
		--return "|cffFFF130Tank|r"
		return "|cffFFF130T|r" -- T
	elseif role == "DAMAGER" then
	--return "|cffEEEE00D|r" --symbol
		--return "|cffFF6161DPS|r"
		return "|cffFF6161D|r" -- D
	end
end


tags.Events["sqw:perhp"] = 'UNIT_HEALTH UNIT_MAXHEALTH'
tags.Methods["sqw:perhp"] = function(u)
	local m = UnitHealthMax(u)
	if(m == 0) then
		return 0
	else
		return math.floor((UnitHealth(u)/m*100+.05)*10)/10
	end
end

tags.Events['sqw:hp'] = 'UNIT_HEALTH UNIT_MAXHEALTH'
tags.Methods['sqw:hp']  = function(u) 
  	if UnitIsDead(u) or UnitIsGhost(u) or not UnitIsConnected(u) then
		return _TAGS["sqw:DDG"](u)
	else
		local per = _TAGS["sqw:perhp"](u).."%" or 0
		local min, max = UnitHealth(u), UnitHealthMax(u)
		if u == "player" then
			if min~=max then 
			
				return "|cffFFFFFF"..--[[..SVal(min)--.."|r/"..SVal(max).."                "..]]per
			else
				return SVal(max)--.." | "..per
			end
		elseif u == "target"  then
			if min~=max then 
				return "|cffFFFFFF"..per--[[.."                ".."|cFFFFAAAA"..SVal(min)--return "|cFFFFAAAA"..SVal(min).."|r/"..SVal(max).." | "..per]]
			else
				return SVal(max)--.." | "..per
			end
		else
			return per
		end
	end
end

tags.Events["sqw:raidhp"] = 'UNIT_HEALTH UNIT_CONNECTION PLAYER_FLAGS_CHANGED'
tags.Methods["sqw:raidhp"] = function(u) 
  if UnitIsDead(u) or UnitIsGhost(u) or not UnitIsConnected(u) then
    return _TAGS["sqw:DDG"](u)
  else
	
	local missinghp = --[[SVal(_TAGS["missinghp"](u)) or]] ""
	if missinghp ~= "" then
		return "-"..missinghp
	else
		return ""
	end
  end
end

tags.Events['sqw:color'] = 'UNIT_REACTION UNIT_HEALTH UNIT_HAPPINESS'
tags.Methods['sqw:color'] = function(u, r)
		local _, class = UnitClass(u)
	local reaction = UnitReaction(u, "player")
	
	if UnitIsDead(u) or UnitIsGhost(u) or not UnitIsConnected(u) then
		return "|cffA0A0A0"
	elseif (UnitIsTapped(u) and not UnitIsTappedByPlayer(u)) then
		return hex(oUF.colors.tapped)
	elseif (u == "pet") then
		return hex(oUF.colors.class[class])
	elseif (UnitIsPlayer(u)) then
		return hex(oUF.colors.class[class])
	elseif reaction then
		return hex(oUF.colors.reaction[reaction])
	else
		return hex(1, 1, 1)
	end
end

tags.Events["sqw:afkdnd"] = 'PLAYER_FLAGS_CHANGED UNIT_POWER UNIT_MAXPOWER'
tags.Methods["sqw:afkdnd"] = function(unit) 
	return UnitIsAFK(unit) and "|cffCFCFCF <afk>|r" or UnitIsDND(unit) and "|cffCFCFCF <dnd>|r" or ""
end

tags.Events['sqw:DDG'] = 'UNIT_HEALTH'
tags.Methods['sqw:DDG'] = function(u)
	if UnitIsDead(u) then
		return "|cffCFCFCF Dead|r"
	elseif UnitIsGhost(u) then
		return "|cffCFCFCF Ghost|r"
	elseif not UnitIsConnected(u) then
		return "|cffCFCFCF D/C|r"
	end
end

tags.Events['sqw:power'] = 'UNIT_POWER UNIT_MAXPOWER'
tags.Methods['sqw:power']  = function(u) 
	local min, max = UnitPower(u), UnitPowerMax(u)
	if min~=max then 
		return SVal(min).."/"..SVal(max)
	else
		return SVal(max)
	end
end
tags.Events["sqw:perpp"] = 'UNIT_POWER UNIT_MAXPOWER'
tags.Methods["sqw:perpp"] = function(u)
	local m = UnitPowerMax(u)
	if(m == 0) then
		return 0
	else
		return math.floor((UnitPower(u)/m*100+.05)*10)/10
	end
end
tags.Events['sqw:pp'] = 'UNIT_POWER UNIT_MAXPOWER'
tags.Methods['sqw:pp']  = function(u) 
  			local per = _TAGS["sqw:perpp"](u).."%" or 0
		local min, max = UnitPower(u), UnitPowerMax(u)
		if u == "player" then
			if min~=max then 
			
				return per
			else
				return SVal(max)
			end
		end
	end



-- Level
tags.Events["sqw:level"] = "UNIT_LEVEL PLAYER_LEVEL_UP UNIT_CLASSIFICATION_CHANGED"
tags.Methods["sqw:level"] = function(unit)
	
	local c = UnitClassification(unit)
	local l = UnitLevel(unit)
	local d = GetQuestDifficultyColor(l)
	
	local str = l
		
	if l <= 0 then l = "??" end
	
	if c == "worldboss" then
		str = string.format("|cff%02x%02x%02xBoss|r",250,20,0)
	elseif c == "eliterare" then
		str = string.format("|cff%02x%02x%02x%s|r|cff0080FFR|r+",d.r*255,d.g*255,d.b*255,l)
	elseif c == "elite" then
		str = string.format("|cff%02x%02x%02x%s|r+",d.r*255,d.g*255,d.b*255,l)
	elseif c == "rare" then
		str = string.format("|cff%02x%02x%02x%s|r|cff0080FFR|r",d.r*255,d.g*255,d.b*255,l)
	else
		if not UnitIsConnected(unit) then
			str = "??"
		else
			if UnitIsPlayer(unit) then
				str = string.format("|cff%02x%02x%02x%s",d.r*255,d.g*255,d.b*255,l)
			elseif UnitPlayerControlled(unit) then
				str = string.format("|cff%02x%02x%02x%s",d.r*255,d.g*255,d.b*255,l)
			else
				str = string.format("|cff%02x%02x%02x%s",d.r*255,d.g*255,d.b*255,l)
			end
		end		
	end
	
	return str
end
